;------------------------------------------------------------------------------
;
;	Extended Country Information for DOS   YASM/NASM code
;
; > yasm -fbin -o eci.com eci.asm
; > yasm -fbin -DSIZE5 -o eci5.com eci5.asm
; > yasm -fbin -DUNPACK -o eci_upck.com eci5.asm
;
;------------------------------------------------------------------------------

	BITS 16

	org 100h
	section .text

_start:
	push	di
	push	es
	mov		ax,ds
	mov		es,ax			; buffer segment
	mov		di,eci			; buffer offset

	mov		ax,6501h		; get international info
	mov		bx,0ffffh		; global code page
%ifndef SIZE5
	mov		cx,0007h		; buffer size
%else
	mov		cx,0005h		; buffer size
%endif
	mov		dx,0ffffh		; current country
	int     21h
	jc		.no_eci

	std						; Set Direction Flag
;	lea		di,word [type]
	mov		di,type
	inc		di
	xor		ax,ax
	mov		al,byte [eci+0]	; InfoID
	mov		cx,2
	call	n2a

;	lea		di,word [size]
	mov		di,size
	add		di,3
%ifndef UNPACK
	mov		ax,word [eci+1]	; Buffer Size
%else
	mov		ax,word [eci+2]	; Buffer Size
%endif
	mov		cx,4
	call	n2a

;	lea		di,word [cid]
	mov		di,cid
	add		di,3
%ifndef UNPACK
	mov		ax,word [eci+3]	; country ID
%else
	mov		ax,word [eci+4]	; country ID
%endif
	mov		cx,4
	call	n2a

%ifndef SIZE5
;	lea		di,word [cp]
	mov		di,cp
	add		di,3
%ifndef UNPACK
	mov		ax,word [eci+5]	; global code page
%else
	mov		ax,word [eci+6]	; global code page
%endif
	mov		cx,4
	call	n2a
%endif

	cld						; Clear Direction Flag
	jmp		.msgdsp

.no_eci:
	pop		ds
	mov		dx,noeci_msg
	mov		ah,09h
	int		21h
	jmp		.done

.msgdsp:
	mov		dx,ecimsg
	mov     ah,09h		; stdout
	int     21h

.done:
	pop		es
	pop		di
	mov     ax,4c00h	; sys_exit
	int     21h


; number to ascii
n2a:
	mov		bx,10

.n2a:
	xor		dx,dx
	div		bx

	push	ax
	mov		ax,dx
	add		ax,'0'
	stosb
	pop		ax

	loop	.n2a
@@:
	ret


section .data
eci		resb	40

noeci_msg   db  'Extended Country Information is not supported.', 0dh, 0ah, '$'

ecimsg	db	'Extended Country Information', 0dh, 0ah, 'Type: '
type	resb	2
		db	0dh, 0ah, 'Size: '
size	resb	4
		db	0dh, 0ah, 'CountryID: '
cid		resb	4
%ifndef SIZE5
		db	0dh, 0ah, 'CodePage: '
cp		resb	4
%endif
		db	0dh, 0ah, '$'


section .bss

